import es
import gamethread
import keyvalues
import playerlib
import popuplib

info = es.AddonInfo()
info.name          = "Type"
info.basename      = "type"
info.version       = "1.0"
info.author        = "Adam"
info.description   = "Allows certain users to avoid typekill with '!type'"

es.ServerVar(info.basename, info.version).makepublic()

typeAdminList = []
mani_admins = "On" # USE MANI ADMIN'S CLIENTS.TXT FILE FOR TYPEADMINS? On / Off
typeUserList = []

def load():
    global typeCommand, addCommand, manageCommand, mani_admins
    typeCommand = "!type"
    es.regsaycmd('%s' % typeCommand, 'type/typeCmd')
    addCommand = "!add"
    es.regsaycmd('%s' % addCommand, 'type/addCmd')

    if mani_admins == "On":
        clients = keyvalues.KeyValues('clients.txt')
        clients.load(filename="cfg/mani_admin_plugin/clients.txt")
        typeAdminList = [x['steam'] for x in clients['players']]

    playerList = popuplib.construct('PlayerList', 'players', '#all', playerList_menuselect)

    typeOption = popuplib.create('typeOption') 
    typeOption.addline('[Gr] :: Type')
    typeOption.addline('------------')
    typeOption.addline('->1. Move Spectate')
    typeOption.addline('->2. Make Invincible')
    typeOption.addline('------------')
    typeOption.addline('0. Cancel')
    typeOption.menuselect = typeOption_menuselect

    giveAdmin = popuplib.create('giveAdmin') 
    giveAdmin.addline('[Gr] :: Type')
    giveAdmin.addline('------------')
    giveAdmin.addline('->1. Make TypeAdmin')
    giveAdmin.addline('->2. Make TypeUser')
    giveAdmin.addline('------------')
    giveAdmin.addline('0. Cancel')
    giveAdmin.menuselect = giveAdmin_menuselect

    giveAdminConfirm = popuplib.create('giveAdminConfirm') 
    giveAdminConfirm.addline('[Gr] :: Type')
    giveAdminConfirm.addline('------------')
    giveAdminConfirm.addline('Please Confirm [TypeAdmin Rights]')
    giveAdminConfirm.addline('->1. Yes')
    giveAdminConfirm.addline('->1. NO. Go Back')
    giveAdminConfirm.addline('------------')
    giveAdminConfirm.addline('0. Cancel')
    giveAdminConfirm.menuselect = giveAdminConfirm_menuselect

    es.msg('#multi', '#green[Type] #defaultis enabled.')

def unload():
    popuplib.delete('typeOption')
    popuplib.delete('giveAdmin')
    popuplib.delete('giveAdminConfirm')
    es.unregsaycmd('%s' % typeCommand)
    es.unregsaycmd('%s' % addCommand)
    es.msg('#multi', '#green[Type] #defaultis disabled.')

def typeCmd():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    if steamid in typeUserList or steamid in typeAdminList:
        popuplib.send('typeOption', userid)
    else: es.tell(userid, '#multi', '#green[Type] #lightgreenYou do not have the permissions to use this command')

def addCmd():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    if steamid in typeAdminList:
        popuplib.send('PlayerList', userid)
    else: es.tell(userid, '#multi', '#green[Type] #lightgreenYou must be a TypeAdmin to use this command')

def typeOption_menuselect(userid, choice, popupid):
    global primary, secondary, hegrenade, flashbang, smokegrenade, c4
    player = playerlib.getPlayer(userid)
    if choice == 1:
        es.changeteam(userid,'1')
        es.msg('#multi', '#green[Type] #default#lightgreen%s #defaulthas been moved to spectate to avoid TypeKill.' % es.getplayername(userid))
    if choice == 2:
        primary = player.get("primary")
        secondary = player.get("secondary")
        hegrenade = player.get("HE")
        flashbang = player.get("FB")
        smokegrenade = player.get("SG")
        c4 = player.get("C4")
        locationChange(userid)
        removeWeapons(userid)
        es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 0) 
        es.msg('#multi', '#green[Type] #lightgreen%s #defaulthas been made invincible to avoid TypeKill.' % es.getplayername(userid))
        es.tell(userid, '#multi', '#green[Type] #defaultYou will be returned mortal after either 20 seconds or if you move.')
        gamethread.delayedname(20, 'removeInvincibility(%s)' % userid, removeInvincibility, (userid)) 

def playerList_menuselect(userid, choice, popupname):
    global choicename, choiceuserid
    choicename = es.getplayername(choice)
    choiceuserid = es.getuserid(choicename)
    popuplib.send('giveAdmin', userid) 

def giveAdmin_menuselect(userid, choice, popupid):
    if choice == 1:
        popuplib.send('giveAdminConfirm', userid)
    if choice == 2:
        typeUserList.append(es.getplayersteamid(choiceuserid))
        es.tell(userid, '#multi', '#green[Type] #lightgreenYou successfully added %s to TypeUserList.' % choicename)
        es.tell(choiceuserid, '#multi', '#green[Type] #lightgreenYou have successfully been added to TypeUserList.')
        es.tell(choiceuserid, '#multi', '#green[Type] #lightgreenTo avoid TypeKill, say !type in chat. For ease of use, bind this to a key. #defaultType in console: bind <key> "say !type".')

def giveAdminConfirm_menuselect(userid, choice, popupid):
    if choice == 1:
        typeAdminList.append(es.getplayersteamid(choiceuserid))
        es.tell(userid, '#multi', '#green[Type] #lightgreenYou successfully added %s to TypeAdminList.' % choicename)
        es.tell(choiceuserid, '#multi', '#green[Type] #lightgreenYou have successfully been added to TypeAdminList.')
        es.tell(choiceuserid, '#multi', '#green[Type] #lightgreenTo avoid TypeKill, say !type in chat. For ease of use, bind this to a key. #defaultType in console: bind <key> "say !type".')
        es.tell(choiceuserid, '#multi', '#green[Type] #lightgreenTo add TypeUsers, type !add in chat to receive popupmenu.')
    if choice == 2:
        popuplib.send('giveAdmin', userid)

def removeInvincibility(userid):
    if es.getplayerprop(userid, 'CBasePlayer.m_lifeState') == 0:
        es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 512)
        es.msg('#multi', '#green[Type] #lightgreen%s #defaultis no longer invincible.' % es.getplayername(userid))
        es.server.queuecmd('es_xgive %s weapon_%s' %(userid, primary))
        es.server.queuecmd('es_xgive %s weapon_%s' %(userid, secondary))
        es.server.queuecmd('es_xgive %s weapon_%s' %(userid, hegrenade))
        es.server.queuecmd('es_xgive %s weapon_%s' %(userid, flashbang))
        es.server.queuecmd('es_xgive %s weapon_%s' %(userid, smokegrenade))
        es.server.queuecmd('es_xgive %s weapon_knife' % userid)
        if c4 == '1':
            es.server.queuecmd('es_xgive %s weapon_c4' % userid)

def locationChange(userid):
    playerLocation = es.getplayerprop(userid, "CBaseEntity.m_vecOrigin")
    if playerLocation != playerLocation:
        removeInvincibility(userid)
    gamethread.delayedname(0.1, 'locationChange(%s)' % userid, locationChange, (userid))

def removeWeapons(userid):
    es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
    es.server.queuecmd('es_xfire %s player_weaponstrip Strip' % userid)